Index: trunk/gui/scripts/analyzer.tcl
===================================================================
--- trunk/gui/scripts/analyzer.tcl	(revision 6716)
+++ trunk/gui/scripts/analyzer.tcl	(revision 1)
@@ -529,253 +207,34 @@
 # to "auto", the simulation is invoked immediately.
 # ----------------------------------------------------------------------
-itcl::body Rappture::Analyzer::reset {{when -eventually}} {
-    if {$when == "-eventually"} {
-        after cancel [list catch [itcl::code $this reset -now]]
-        after idle [list catch [itcl::code $this reset -now]]
-        return
-    }
-
-    # check to see if simulation is really needed
-    $_tool sync
-    if {![$_resultset contains [$_tool xml object]] ||
-        [string equal $_control "manual-resim"]} {
-        # if control mode is "auto", then simulate right away
-        if {[string match auto* $_control]} {
-            # auto control -- don't need button
-            pack forget $itk_interior.simol
-
-            after cancel [itcl::code $this simulate]
-            after idle [itcl::code $this simulate]
-        } else {
-            _simState on "new input parameters"
-        }
-    } else {
-        _simState off
-    }
-}
-
-# ----------------------------------------------------------------------
-# USAGE: load <xmlobj>
-#
-# Loads the data from the given <xmlobj> into the appropriate results
-# sets.  If necessary, new results sets are created to store the data.
-# ----------------------------------------------------------------------
-itcl::body Rappture::Analyzer::load {xmlobj} {
-    # only show the last result? then clear first
-    if {[string trim [$_tool xml get tool.analyzer]] == "last"} {
-        clear
-    }
-    #puts "Analyzer::load"
-    $_resultset add $xmlobj
-
-    # NOTE: Adding will trigger a !change event on the ResultSet
-    # object, which will trigger calls to _fixResultSet to add
-    # the results to display.
-}
-
-# ----------------------------------------------------------------------
-# USAGE: clear ?<xmlobj>?
-#
-# Discards one or more results previously loaded into the analyzer.
-# If an <xmlobj> is specified, then that one result is cleared.
-# Otherwise, all results are cleared.
-# ----------------------------------------------------------------------
-itcl::body Rappture::Analyzer::clear {{xmlobj "all"}} {
-    if {$xmlobj eq "" || $xmlobj eq "all"} {
-        $_resultset clear
-    } else {
-        $_resultset clear $xmlobj
-    }
-
-    # NOTE: Clearing will trigger a !change event on the ResultSet
-    # object, which will trigger calls to _fixResultSet to clean up
-    # the results being displayed.
-}
-
-# ----------------------------------------------------------------------
-# USAGE: download coming
-# USAGE: download controls <downloadCommand>
-# USAGE: download start ?widget?
-# USAGE: download now ?widget?
-#
-# Spools the current result so the user can download it.
-# ----------------------------------------------------------------------
-itcl::body Rappture::Analyzer::download {option args} {
-    set title [$itk_component(viewselector) value]
-    set page [$itk_component(viewselector) translate $title]
-
-    switch -- $option {
-        coming {
-            #
-            # Warn result that a download is coming, in case
-            # it needs to take a screen snap.
-            #
-            if {![regexp {^(|@download|---)$} $page]} {
-                set f [$itk_component(resultpages) page $page]
-                $f.rviewer download coming
-            }
-        }
-        controls {
-            # no controls for this download yet
-            return ""
-        }
-        start {
-            set widget $itk_component(download)
-            if {[llength $args] > 0} {
-                set widget [lindex $args 0]
-                if {[catch {winfo class $widget}]} {
-                    set widget $itk_component(download)
-                }
-            }
-            #
-            # See if this download has any controls.  If so, then
-            # post them now and let the user continue the download
-            # after selecting a file format.
-            #
-            if {$page != ""} {
-                set ext ""
-                set f [$itk_component(resultpages) page $page]
-                set arg [itcl::code $this download now $widget]
-                set popup [$f.rviewer download controls $arg]
-                if {"" != $popup} {
-                    $popup activate $widget below
-                } else {
-                    download now $widget
-                }
-            } else {
-                # this shouldn't happen
-                set file error.html
-                set data "<h1>Not Found</h1>There is no result selected."
-            }
-        }
-        now {
-            set widget $itk_component(download)
-            if {[llength $args] > 0} {
-                set widget [lindex $args 0]
-                if {[catch {winfo class $widget}]} {
-                    set widget $itk_component(download)
-                }
-            }
-            #
-            # Perform the actual download.
-            #
-            if {$page != ""} {
-                set ext ""
-                set f [$itk_component(resultpages) page $page]
-                set item [$itk_component(viewselector) value]
-                set result [$f.rviewer download now $widget $_appName $item]
-                if { $result == "" } {
-                    return;                # User cancelled the download.
-                }
-                foreach {ext data} $result break
-                if {"" == $ext} {
-                    if {"" != $widget} {
-                        Rappture::Tooltip::cue $widget \
-                            "Can't download this result."
-                    }
-                    return
-                }
-                regsub -all {[\ -\/\:-\@\{-\~]} $title {} title
-                set file "$title$ext"
-            } else {
-                # this shouldn't happen
-                set file error.html
-                set data "<h1>Not Found</h1>There is no result selected."
-            }
-
-            Rappture::Logger::log download [$itk_component(viewselector) value]
-            set mesg [Rappture::filexfer::download $data $file]
-            if {[string length $mesg] > 0} {
-                Rappture::Tooltip::cue $widget $mesg
-            }
-        }
-        default {
-            error "bad option \"$option\": should be coming, controls, now, start"
-        }
-    }
-}
-
-# ----------------------------------------------------------------------
-# USAGE: _plot ?<index> <options> <index> <options>...?
-#
-# Used internally to update the plot shown in the current result
-# viewer whenever the resultselector settings have changed.  Causes the
-# desired results to show up on screen.
-# ----------------------------------------------------------------------
-itcl::body Rappture::Analyzer::_plot {args} {
-    #puts "analyzer::_plot"
-    set _plotlist $args
-
-    set page [$itk_component(viewselector) value]
-    set page [$itk_component(viewselector) translate $page]
-    if {"" != $page} {
-        set f [$itk_component(resultpages) page $page]
-        $f.rviewer plot clear
-        foreach {index opts} $_plotlist {
-            $f.rviewer plot add $index $opts
-        }
-    }
-}
-
-# ----------------------------------------------------------------------
-# USAGE: _reorder <compList>
-#
-# Used internally to change the order of a series of output components
-# found in the <output> section.  Moves the <log> elements to the end
-# and returns the updated list.
-# ----------------------------------------------------------------------
-itcl::body Rappture::Analyzer::_reorder {comps} {
-    set i 0
-    set max [llength $comps]
-    while {$i < $max} {
-        set c [lindex $comps $i]
-        if {[string match log* $c]} {
-            set comps [lreplace $comps $i $i]
-            lappend comps $c
-            incr max -1
-        } else {
-            incr i
-        }
-    }
-    return $comps
-}
-
-# ----------------------------------------------------------------------
-# USAGE: _autoLabel <xmlobj> <path> <title> <cntVar>
-#
-# Used internally to check for an about.label property at the <path>
-# in <xmlobj>.  If this object doesn't have a label, then one is
-# supplied using the given <title>.  The <cntVar> is an array of
-# counters in the calling scopes for titles that have been used
-# in the past.  This is used to create titles like "Plot #2" the
-# second time it is encountered.
-#
-# The <xmlobj> is updated so that the label is inserted directly in
-# the tree.
-# ----------------------------------------------------------------------
-itcl::body Rappture::Analyzer::_autoLabel {xmlobj path title cntVar} {
-    upvar $cntVar counters
-
-    set group [$xmlobj get $path.about.group]
-    set label [$xmlobj get $path.about.label]
-    if {"" == $label} {
-        # no label -- make one up using the title specified
-        if {![info exists counters($group-$title)]} {
-            set counters($group-$title) 1
-            set label $title
-        } else {
-            set label "$title (#[incr counters($group-$title)])"
-        }
-        $xmlobj put $path.about.label $label
-    } else {
-        # handle the case of two identical labels in <output>
-        if {![info exists counters($group-$label)]} {
-            set counters($group-$label) 1
-        } else {
-            set label "$label (#[incr counters($group-$label)])"
-            $xmlobj put $path.about.label $label
-        }
-    }
-    return $label
+itcl::body Rappture::Analyzer::reset {} {
+    $itk_component(notebook) current simulate
+
+    # if control mode is "auto", then simulate right away
+    if {$_control == "auto"} {
+        simulate
+    }
+}
+
+# ----------------------------------------------------------------------
+# USAGE: load <file>
+#
+# Used to reset the analyzer whenever the input to a simulation has
+# changed.  Sets the mode back to "simulate", so the user has to
+# simulate again to see the output.
+# ----------------------------------------------------------------------
+itcl::body Rappture::Analyzer::load {file} {
+    # clear any old results
+    if {$_run != ""} {
+        itcl::delete object $_run
+        set _run ""
+    }
+
+    # try to load new results from the given file
+    set _run [Rappture::Library::open $file]
+
+    # go through the analysis and create widgets to display results
+    foreach item [array names _widgets] {
+        $_widgets($item) configure -run $_run
+    }
 }
 
